/*         File: PSRUNL.C                                 */
/*                                                         */
/*        SAIL LEAP compatibility package for PSAIL        */
/*                                                         */
char *v_psrunl = {"psrunl@V.56.10"};     /* CURRENT VERSION */
/*                                                         */
/*        P. Lemkin                                        */
/*        Image Processing Section                         */
/*        National Cancer Institute, DCBD, LTB             */
/*	  FCRF, Build 469 Room 150B			   */
/*	  Frederick, MD 21701				   */
/*                                                         */
/*        Revised October 10, 1987                                 */
/*        Revised September 8, 1987                                 */
/*        Revised February 14, 1987                                 */
/*        Revised October 2, 1986                                   */
/*        Revised September 26, 1986                                */
/*        Revised September 20, 1986                                */
/*        Revised September 19, 1986                                */
/*        Revised August 15, 1986                                   */
/*        Revised August 12, 1986                                   */
/*        Revised August 7, 1986                                   */
/*        Revised July 15, 1986                                   */
/*        Revised July 9, 1986                                   */
/*        Revised June 26, 1986                                   */
/*        Revised May 5, 1986                                    */
/*        Revised April 22, 1986                                    */
/*        Revised April 6, 1986                                    */
/*        Revised March 29, 1986                                    */
/*        Revised March 8, 1986                                    */
/*        Revised March 5, 1986                                    */
/*        Revised February 28, 1986                                */
/*        Revised December 14, 1985                                */
/*        November 12, 1985                                	*/

/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*                                                        */
/*                                                        */
/*                                                        */
/* ITEMVAR catLLIST();   concat LEAP lists (iv1, iv2, ...,0) */
/* ITEMVAR copLIST();    return the first item of the list iv */ 
/* ITEMVAR copSET();     return the first item of the set iv */
/* LIST copyLIST();      return a copy of LIST iv */
/* SET copySET();        return a copy of SET iv */
/* INTEGER cvi();        convert ITEM i to INTEGER type */
/* STRING cvis();        convert ITEM i to STRING, flag if error */
/* ITEM cvn();           convert INTEGER number n to ITEM type */
/* LIST cvlist();        convert SET to a LIST */
/* SET cvset();          convert LIST to a SET */
/* ITEM cvsi();          convert STRING *s to ITEM, flag if error */
/* INTEGER datum();      return datum assoc. with item iv */
/* STRING datumC();      return STRING datum assoc. with ITEM iv */
/* double datumD();      return double datum assoc. with ITEM iv */
/* EVENT datumE();       return EVENT datum assoc. with ITEM iv */
/* float datumF();       return float datum assoc. with ITEM iv */
/* INTEGER datumI();     return INTEGER datum assoc. with ITEM iv */
/* LIST datumL();        return LIST datum assoc with ITEM iv */
/* OBJECT datumO();      return OBJECT datum assoc. with ITEM iv */
/* *(datumP())();        return PROCEDURE datum assoc. with ITEM iv */
/* RECPTR datumQ();      return RECORD!POINTER datum assoc. w/ITEM iv*/
/* SET datumS();         return SET datum assoc. with ITEM iv */
/* ITEMVAR datumV();     return ITEMVAR datum assoc. with ITEM iv */
/* SET defSET();         construct explicit Leap SET */
/* LIST defLIST();       construct explicit Leap LIST */
/* void delItem();       delete ITEM iv */
/* void erase();         erase triple (att,obj,value). */
/* LIST explicitLIST();  construct explicit list */
/* ITEM fetchIndexed();  return n'th ITEM from list iv */
/* ITEMVAR fndIN();      find itemvar x in set or list S if any */
/* ITEMVAR fndT();       find itemvar A XOR O EQU V if any else 0 */
/* SET fnd1T();          find set of a XOR O EQU V if any else PHI */
/* SET fnd2T();          find set of A XOR o EQU V if any else PHI */
/* SET fnd3T();          find set of A XOR O EQU v if any else PHI */
/* SET fnd12T();         find set of a XOR o EQU V if any else PHI */
/* SET fnd13T();         find set of a XOR O EQU v if any else PHI */
/* SET fnd23T();         find set of A XOR o EQU v if any else PHI */
/* SET fnd123T();        find set of a XOR o EQU v if any else PHI */
/* ITEMVAR first();      return attribute of triple iv */
/* INTEGER foreach();    SAIL FOREACH loop generator*/
/* INTEGER inLIST();     test if ITEM ivE in list ivList */
/* INTEGER inSET();      test if ITEM ivE in set ivSet */
/* INTEGER istriple();   return true if ITEMVAR iv==bracketed triple */
/* INTEGER lenLIST();    return length of list iv */
/* INTEGER lenSET();     return length of set iv */
/* LIST listDiff();      return list difference of iv1 and iv2 */
/* INTEGER listEqu();    return TRUE if iv1 and iv2 are the same */
/* LIST listInter();     return intersection of iv1 and iv2 */
/* LIST listUnion();     return Union of lists iv1 and iv2 */
/* ITEMVAR lopITEM();    return 1st ITEM & shorten list or set iv */
/* ITEMVAR lopLIST();    return first ITEM of list iv, shorten iv */
/* ITEMVAR lopSET();     return first ITEM of set iv, shorten iv */
/* void make();          make triple (att,obj,value) */
/* void mkItem();        create SET, LIST, ITEM id w/descriptor word */
/* ITEMVAR newitem();    return a new ITEM number */
/* ITEMVAR newExample(); return new ITEM copy of id w/same type&size*/
/* void new_pname();     set ITEM i's print name to STRING s*/
/* INTEGER props();      return INTEGER value of ITEM iv */
/* void put();           put ITEM x in set  or list y */
/* void putafter();      put ITEM x in set y after z */
/* void putbefore();     put ITEM x in set y before z */
/* void putIndexed();    put ITEM x in set y before element n */
/* void remAll();        remove all element x from list ivList */
/* void remIndexed();    remove element n from list ivList */
/* void remList();       remove ITEM x from list ivList */
/* void remListAll();    remove All of ITEM x from list ivList */
/* void remSet(x,ivSet); remove ITEM x from set ivSet */
/* INTEGER sameiv();     return true if ITEM iv1 = ITEM iv2 */
/* void saveDatum();     save value into datum of ITEM iv */
/* SET setDiff();        return set difference of sets iv1 and iv2 */
/* INTEGER setEqu();     return TRUE if iv1 and iv2 are the same */
/* SET setInter();       return intersection of sets iv1 and iv2*/
/* SET setUnion();       return Union of sets iv1 and iv2 */
/* ITEMVAR second();     return object of triple iv */
/* ITEMVAR third();      return value of triple iv */
/* INTEGER typeit();     return type code of datum of ITEM iv */
/*	-----------------------------------------------		*/
/*	-	I N C L U D E   S U B - M O D U L E S		*/
/*	-----------------------------------------------		*/

#include "config.h"		/* declare HAS... primary macros */
#include "confg2.h"		/* declare 2ndary HAS... macros */
#include "psrdef.h"		/* "sairun.c" runtime only macros */
#include "psrglb.h"		/* "sairun.c" globals*/

/* The following functions are found in psrun1.c */
STRING cvs();             /* convert INTEGER to string */



/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    G L O B A L    V A R I A B L E S / M A C R O S	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/


typedef struct itemnode {INTEGER descriptorWord,
                        propsWord,
                        recordClassPtr;
                STRING  pName;
                union {LISP_ATOM vAtomLisp;
                       LISP_SEXPR vSexprLisp;
                       STRING vString;
                       INTEGER vInteger;
                       float vFloat;
                       double vDouble;
                       LIST vList;
                       SET vSet;
                       ITEM vItem;
                       INTEGER vItemvar;
                       void (*vProcess)();
                       INTEGER *vRecordPtr;
                       EVENT vEvent;
                       OBJECT vObject;
                      } datmValue;
                } iNode_t;
/*
*	Note that any strings which are allocated to the iNode_t
* such as the pName or vstring should be put on the "active LEAP string
* pointer PDL" [NOTE:@V.56.09 currently does not exist] so this can
* be used by gcrun() when doing G.C. If we arepaging the associative
* data base, then we must take this into accountbefore paging the items
* which contain strings. Or another data structure might be used
* to store the strings.
*
*	If the items are in core the the following SAIL function for
* accessing a REAL ITEMVAR x
*
*	Datum(x)
*
* maps to the C code:
*
*	*datumF(x)
*
* This will return the POINTER to the value so that we can handle
* arrays.
*/
/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */
/* iNode_t *accessMethod(iv) looks up the iNode_t for the        */
/* itemvar iv. See:						   */
/* 1. Feldman, J.A., Rovner, P.D., An Algol-Based Associative 	   */
/* Language. CACM 12(8) 439-449 (1969).				   */
/* 2. Low, J.R., Automatic coding: choice of data structures. Univ. */
/* Rochester Dept. Computer Sci. TR_#1. Aug., (1974). Also Stanford */
/* Comp. Sci. Dept memo STAN-CS-74-452.				    */
/*								   */
static iNode_t *accessMethod(iv)
	ITEMVAR iv;
{
	iNode_t *inp;	/* pointer to item node */

/*  -- add code -- */
	return(inp);
}



/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumC(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
STRING PROCEDURE datumC(x)
	ITEMVAR x;
{
 iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 GC_SRETURN(q->datmValue.vString)
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumD(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
double PROCEDURE *datumD(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vDouble));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumE(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
EVENT PROCEDURE *datumE(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vEvent));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumF(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
float PROCEDURE *datumF(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vFloat));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumH(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
LISP_ATOM PROCEDURE *datumH(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vAtomLisp));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumI(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
INTEGER PROCEDURE *datumI(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vInteger));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumJ(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
OBJECT PROCEDURE *datumJ(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vObject));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumK(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
LISP_SEXPR PROCEDURE *datumK(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vSexprLisp));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumL(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
LIST PROCEDURE *datumL(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vList));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumP(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
void PROCEDURE *datumP(x)
	ITEMVAR x;
{
 iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return((void *)
(q->datmValue.vProcess));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumQ(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
INTEGER PROCEDURE *datumQ(x)
	ITEMVAR x;
{
 iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return((INTEGER *)(q->datmValue.vRecordPtr));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumS(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
SET PROCEDURE *datumS(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vSet));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumV(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
ITEMVAR PROCEDURE *datumV(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vItemvar));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function datumX(ITEMVAR x)					   */
/* Note that a pointer to the data is returned - not the data      */
/* itself. This is necessary so that we can handle arrays if       */
/* necessary.                                                      */
/*                                                                 */
ITEMVAR PROCEDURE *datumX(x)
	ITEMVAR x;
{iNode_t *q;
 q=accessMethod(x);	/* get associated struct pointer */
 return(&(q->datmValue.vItem));
}


/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*  Function newExample(Reference Integer id; INTEGER dw, size)	   */
/*                                                                 */
ITEMVAR PROCEDURE newExample(id,dw,size)
	INTEGER *id;	/* pointer to sample data structure to copy*/
	INTEGER dw;	/* PSAIL descriptor word */
	INTEGER size;	/* number of bytes size of id */
{
iNode_t	*q;
INTEGER		*idPtr;		/* pointer to id */
int		i,		/* counter when copy vectors */
		pType,		/* letter TYPE code of id */
		headerSize;	/* size of the LEAP ITEM header */

idPtr = id;
pType = (dw & 037) ? ((dw & 037)+'a'-1) : 0;
	/* compute number of long words needed */
if (dw & DWarray)
	{ /* make a copy of array */
	 INTEGER totSize,headerSize,dataSize;
	 headerSize = *(id-2);
	 dataSize = *(id-3);
	 totSize = headerSize+dataSize;
	 idPtr = (INTEGER *)Pmalloc(totSize);
	 Carrblt(&idPtr,id,totSize);
	} /* make a copy of array */

q = (iNode_t *)Pmalloc(sizeof(iNode_t));
q->descriptorWord = dw;
q->propsWord = 0;
q->recordClassPtr = 0;
q->pName = 0;		/* NULL string */
for(i=1; i<=size; i++, id++)
   switch (pType)
   { /* copy the value */
   case CODEatomLisp: q->datmValue.vAtomLisp = (LISP_ATOM)id;
   case CODEsExprLisp: q->datmValue.vSexprLisp = (LISP_SEXPR)id;
   case CODEstring: q->datmValue.vString = (STRING)id;
   case CODEinteger: q->datmValue.vInteger = (INTEGER)*id;
   case CODEreal: q->datmValue.vFloat = (float)*id;
   case CODEdouble: q->datmValue.vDouble = (double)*id;
   case CODElist: q->datmValue.vList = (LIST)*id;
   case CODEset: q->datmValue.vSet = (SET)*id;
   case CODEitem: q->datmValue.vItem = (ITEM)*id;
   case CODEitemvar: q->datmValue.vItemvar = (ITEMVAR)*id;
   case CODEprocedure: q->datmValue.vProcess = (void (*)())id;
   case CODErecPtr: q->datmValue.vRecordPtr = id;
   case CODEevent: q->datmValue.vEvent = (EVENT)id;
   case CODEobject: q->datmValue.vObject = (OBJECT)id;
   } /* copy the value */
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*   PROCEDURES TO ADD to <psrunl.c>				*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/* catLLIST(<ivlist>,0) - concat LEAP lists (iv1, iv2, ...,0) */
ITEMVAR PROCEDURE catLLIST(arg)
	ITEMVAR *arg;
{
ITEMVAR x;
return(x);
}


/* copLIST(iv) - return the first item of the list iv */ 
ITEMVAR PROCEDURE copLIST(iv)
	LIST iv;
{
ITEMVAR x;
return(x);
}


/* copSET() - return the first item of the set iv */
ITEMVAR PROCEDURE copSET(iv)
	SET iv;
{
ITEMVAR x;
return(x);
}


/* copyLIST() -  return a copy of LIST iv */
LIST PROCEDURE copyLIST(iv)
	LIST iv;
{
LIST x;
return(x);
}


/* copySET(iv) - return a copy of SET iv */
SET PROCEDURE copySET(iv)
	SET iv;
{
SET x;
return(x);
}


/* cvi(i) - convert ITEM i to INTEGER type */
INTEGER PROCEDURE cvi(i)
	ITEM i;
{
INTEGER k;
return(k);
}


/* cvis(i,flag) - convert ITEM i to STRING, flag if error */
STRING PROCEDURE cvis(i,flag)
	ITEM i;
	INTEGER *flag;
{
STRING s;			/* string to be returned */
iNode_t *q;			/* item node pointed to by itemvar i */

if (*flag==0)
        s=cvs(i);	/* if *flag variable==0 then return item #*/
else	{ /* return print name of item if any */
	*flag = TRUE;		/* assume ok unless find otherwise */
	q = accessMethod(i);	/* get associated struct pointer */
	if (q==0)
	        {s = "\0"; *flag = FALSE;}
	else s = q->pName;
	} /* return print name of item if any */
return(GC_PUSHS(s));		/* push onto string PDL and return */
}


/* cvn(n) - convert INTEGER number n to ITEM type */
ITEM PROCEDURE cvn(n)
	INTEGER n;
{
ITEMVAR x;
return(x);
}


/* cvlist(ivs) - convert SET to a LIST */
LIST PROCEDURE cvlist(ivs)
	SET ivs;
{
ITEMVAR x;
return(x);
}


/* cvset(ivl) - convert LIST to a SET */
SET PROCEDURE cvset(ivl)
	LIST ivl;
{
SET ivs;
return(ivs);
}


/* cvsi(s,flag) - convert STRING *s to ITEM, flag if error */
ITEM PROCEDURE cvsi(s,flag)
	STRING s;
	INTEGER *flag;
{
ITEMVAR iv;

GC_POPS(s);
		/* do an associative lookup by hash of name to item */
return(iv);
}


/* defSET(<item-list>,0) - construct explicit Leap SET */
SET PROCEDURE defSET(arg)
	ITEMVAR *arg;
{
SET ivs;
return(ivs);
}


/* defLIST(<item-list>,0) - construct explicit Leap LIST */
LIST PROCEDURE defLIST(arg)
	ITEMVAR *arg;
{
LIST ivl;
return(ivl);
}


/* delItem(iv) - delete ITEM iv */
void PROCEDURE delItem(iv)
	ITEMVAR iv;
{
}


/* erase(a,o,v) - erase triple (att,obj,value). */
void PROCEDURE erase(a,o,v)
	ITEMVAR a,o,v;
{
}

/* explicitLIST(<item-list>,0) - construct explicit list */
LIST PROCEDURE explicitLIST(arg)
	ITEMVAR *arg;
{
LIST iv;
return(iv);
}


/* fetchIndexed(iv,n) - return n'th ITEM from list iv */
ITEM PROCEDURE fetchIndexed(iv,n)
	ITEMVAR iv;
	INTEGER n;
{
ITEMVAR iz;
return(iz);
}


/* fndIN(x,s) - find itemvar x in set or list S if any */
ITEMVAR PROCEDURE fndIN(x,s)
	ITEMVAR x;
	ITEMVAR s;
{
ITEMVAR z;
return(z);
}


/* fndT(a,o,v) - find itemvar A XOR O EQU V if any else 0 */
ITEMVAR PROCEDURE fndT(a,o,v)
	ITEMVAR a, o, v;
{
ITEMVAR z;
return(z);
}


/* fnd1T(a,O,V) - find set of a XOR O EQU V if any else PHI */
SET PROCEDURE fnd1T(a,O,V)
	ITEMVAR a;
	ITEM O;
	ITEM V;
{
SET ss;
return(ss);
}


/* fnd2T(A,o,V) - find set of A XOR o EQU V if any else PHI */
SET PROCEDURE fnd2T(A,o,V)
	ITEM A;
	ITEMVAR o;
	ITEM V;
{
SET ss;
return(ss);
}


/* fnd3T(A,O,v) - find set of A XOR O EQU v if any else PHI */
SET PROCEDURE fnd3T(A,O,v)
	ITEM A;
	ITEM O;
	ITEMVAR v;
{
SET ss;
return(ss);
}


/* fnd12T(a,o,V) - find set of a XOR o EQU V if any else PHI */
SET PROCEDURE fnd12T(a,o,V)
	ITEMVAR a;
	ITEMVAR o;
	ITEM V;
{
SET ss;
return(ss);
}


/* fnd13(a,O,v) - find set of a XOR O EQU v if any else PHI */
SET PROCEDURE fnd13T(a,O,v)
	ITEMVAR a;
	ITEM O;
	ITEMVAR v;
{
SET ss;
return(ss);
}


/* fnd23T(A,o,v) - find set of A XOR o EQU v if any else PHI */
SET PROCEDURE fnd23T(A,o,v)
	ITEM A;
	ITEMVAR o;
	ITEMVAR v;
{
SET ss;
return(ss);
}


/* fnd123T(a,o,v) - find set of a XOR o EQU v if any else PHI */
SET PROCEDURE fnd123T(a,o,v)
	ITEMVAR a;
	ITEMVAR o;
	ITEMVAR v;
{
SET ss;
return(ss);
}


/* first(iv) - return attribute of triple iv */
ITEMVAR PROCEDURE first(iv)
	ITEMVAR iv;
{
ITEMVAR a;
return(a);
}


/* SAIL FOREACH loop generator */
INTEGER PROCEDURE foreach(arg)
	ITEMVAR *arg;
{
INTEGER flag;
return(flag);
}


/* inLIST(ivE,ivList) - test if ITEM ivE in list ivList */
INTEGER PROCEDURE inLIST(ivE,ivList)
	ITEM ivE;
	LIST ivList;
{
INTEGER flag;
return(flag);
}


/* inSET(ivE,ivSet) - test if ITEM ivE in set ivSet */
INTEGER PROCEDURE inSET(ivE,ivSet)
	ITEM ivE;
	SET ivSet;
{
INTEGER flag;
return(flag);
}


/* istriple(iv) - return true if ITEMVAR iv==bracketed triple */
INTEGER PROCEDURE istriple(iv)
	ITEMVAR iv;
{
INTEGER flag;
return(flag);
}


/* lenLIST(iv) - return length of list iv */
INTEGER PROCEDURE lenLIST(iv)
	LIST iv;
{
INTEGER ll;
return(ll);
}


/* lenSET(iv) - return length of set iv */
INTEGER PROCEDURE lenSET(iv)
	SET iv;
{
INTEGER ls;
return(ls);
}


/* listDiff(iv1,iv2) - return list difference of iv1 and iv2 */
LIST PROCEDURE listDiff(iv1,iv2)
	LIST iv1, iv2;
{
LIST dif;
return(dif);
}


/* listEqu(iv1,iv2) - return TRUE if iv1 and iv2 are the same */
INTEGER PROCEDURE listEqu(iv1,iv2)
	LIST iv1, iv2;
{
INTEGER flag;
return(flag);
}


/* listINTER(iv1,iv2) - return intersection of iv1 and iv2 */
LIST PROCEDURE listInter(iv1,iv2)
	LIST iv1, iv2;
{
LIST iv1I2;
return(iv1I2);
}


/* listUNION(iv1,iv2) - return Union of lists iv1 and iv2 */
LIST PROCEDURE listUnion(iv1,iv2)
	LIST iv1, iv2;
{
LIST iv1U2;
return(iv1U2);
}


/* lopITEM(iv) - return 1st ITEM & shorten list or set iv */
ITEMVAR PROCEDURE lopITEM(iv)
	ITEMVAR iv;
{
ITEMVAR i1;
return(i1);
}


/* lopLIST(iv) - return first ITEM of list iv, shorten iv */
ITEMVAR PROCEDURE lopLIST(iv)
	LIST iv;
{
ITEMVAR iv1;
return(iv1);
}


/* lopSET(iv) - return first ITEM of set iv, shorten iv */
ITEMVAR PROCEDURE lopSET(iv)
	SET iv;
{
ITEMVAR iv1;
return(iv1);
}


/* make triple (att,obj,value) */
void PROCEDURE make(a,o,v)
	ITEMVAR a, o, v;
{
}


/* mkItem() - create SET, LIST, ITEM id w/descriptor word */
void PROCEDURE mkItem()
{
}


/* newitem() - return a new ITEM number */
ITEMVAR PROCEDURE newitem()
{
ITEMVAR n;
return(n);
}


/* new_pname(i,s) - set ITEM i's print name to STRING s*/
void PROCEDURE new_pname(i,s)
	ITEMVAR i;
	STRING s;
{
}


/* props(iv) - return INTEGER value of ITEM iv */
INTEGER PROCEDURE props(iv)
	ITEMVAR iv;
{
INTEGER val;
return(val);
}


/* put(x,y) - put ITEM x in set or list y */
void PROCEDURE put(x,y)
	ITEM x;
	ITEMVAR y;
{
}


/* putafter(x,y,z) - put ITEM x in set y after z */
void PROCEDURE putafter(x,y,z)
	ITEM x;
	ITEMVAR y;
	ITEM z;
{
}


/* putbefore(x,y,z) - put ITEM x in set y before z */
void PROCEDURE putbefore(x,y,z)
	ITEM x;
	ITEMVAR y;
	ITEM z;
{
}



/* putIndexed(x,y,n) - put ITEM x in set y before element n */
void PROCEDURE putIndexed(x,y,n)
	ITEM x;
	ITEMVAR y;
	INTEGER n;
{
}


/* remAll(x,ivList) - remove all element x from list ivList */
void PROCEDURE remAll(x,ivList)
	ITEM x;
	LIST ivList;
{
}



/* remIndexed(n,ivList) - remove element n from list ivList */
void PROCEDURE remIndexed(n,ivList)
	INTEGER n;
	LIST ivList;
{
}



/* remList(x,ivList) - remove ITEM x from list ivList */
void PROCEDURE remList(x,ivList)
	ITEM x;
	ITEMVAR ivList;
{
}



/* remListAll(x,ivList) - remove All of ITEM x from list ivList */
void PROCEDURE remListAll(x,ivList)
	ITEM x;
	ITEMVAR ivList;
{
}



/* remSet(x,ivSet) - remove ITEM x from set ivSet */
void PROCEDURE remSet(x,ivSet)
	ITEM x;
	SET ivSet;
{
}



/* saveiv(iv1,iv2) - return true if ITEM iv1 = ITEM iv2 */
INTEGER PROCEDURE sameiv(iv1,iv2)
	ITEM iv1, iv2;
{
INTEGER flag;
return(flag);
}


/* saveDatum(iv,value) - save value into datum of ITEM iv */
void PROCEDURE saveDatum(iv,value)
	ITEMVAR iv;
	INTEGER value;
{
}


/* setDiff(iv1,iv2) - return set difference of sets iv1 and iv2 */
SET PROCEDURE setDiff(iv1,iv2)
	SET iv1, iv2;
{
SET dif;
return(dif);
}


/* setEqu(iv1,iv2) - return TRUE if iv1 and iv2 are the same */
INTEGER PROCEDURE setEqu(iv1,iv2)
	SET iv1, iv2;
{
INTEGER flag;
return(flag);
}


/* setInter(iv1,iv2) - return intersection of sets iv1 and iv2*/
SET PROCEDURE setInter(iv1,iv2)
	SET iv1, iv2;
{
SET iv1S2;
return(iv1S2);
}


/* setUnion(iv1,iv2) - return Union of sets iv1 and iv2 */
SET PROCEDURE setUnion(iv1,iv2)
	SET iv1, iv2;
{
SET iv1U2;
return(iv1U2);
}


/* second(iv) - return object of triple iv */
ITEMVAR PROCEDURE second(iv)
	ITEMVAR iv;
{
ITEMVAR iv2;
return(iv2);
}


/* third(iv) - return value of triple iv */
ITEMVAR PROCEDURE third(iv)
	ITEMVAR iv;
{
ITEMVAR iv3;
return(iv3);
}


/* typeit(iv) - return type code of datum of ITEM iv */
INTEGER PROCEDURE typeit(iv)
	ITEMVAR iv;
{
INTEGER typ;
return(typ);
}


/* ---> END OF PSRUNL.C <--- */
