/* 		File: <gogtab.h>				*/
/*                                                                */
/*        -- SAIL SYMBOLIC USER TABLE (gogtab[]) INDICES --	*/
/*                                                                */
/*                                                                */
/*        P. Lemkin                                               */
/*        Image Processing Section                                */
/*        National Cancer Institute, DCBD, LTB                    */
/*        FCRF, Bld 469, Rm 150                           	*/
/*        Frederick Md 21701                                      */
/*                                                                */
/*        Version: 57.10                                          */
/*        Revised June 27, 1987                                   */
/*        Revised December 21, 1986                                 */
/*
*    COPYRIGHT NOTICE - copyright (c) 1983-1986 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*
      This was copied from the SAIL GOGTAB.DEF file of 17-DEC-76.
@V.55.07 gogtab[0:255] exists currently as an array in <psrglb.c/.h>
but is not updated at this time by the PSAIL runtimes.
*/

#define WDTH	0121
#define SPARUT	0251
#define HASMSK	054
#define ATTOP	075
#define RGCOFF	0246
#define BLKTAB	071
#define SCHDRQ	0221
#define TOPBYT	011
#define __FREL	0255
#define RGCRHO	0250
#define DISPAT	0230
#define STBLST	0245
#define LONGWD	0130
#define PRPN	0127
#define ARYLS	070
#define INTQWP	0223
#define DATAB	050
#define FSTATS	042
#define XPAND	074
#define PDL	043
#define BKTPRV	034
#define STTOP	07
#define SGROUT	04
#define INTQWT	0225
#define ST	06
#define __FREC	0262
#define FREITM	066
#define INFOTA	047
#define IPDP	0232
#define REBP	061
#define SPLNK	02
#define CODAC	0120

#define SCBCHN	065
#define SGCNUM	0115		/* number of strings GCed */
#define PRTINF	0252
#define STACS	0162
#define INTPRC	0227
#define FRELST	073
#define __FINT	0254
#define IJBTPC	0234
#define STLIST	010
#define PUBP	060
#define ERBP	057
#define MKBP	056
#define PATHBL	0263
#define ISPDP	0236
#define NOSHRK	076
#define FRLOC	064
#define FP2	053
#define ARYDIR	067
#define FP1	052
#define TTYCVT	041
#define PRNINF	0240
#define BKTPTR	035
#define LOWC	071
#define SPDL	044
#define HASTAB	051
#define __FSET	0257
#define STINCR	0110
#define __FLST	0260
#define IRUNNR	0235
#define EXT	0125
#define WD3	0126
#define RSGCL2	0244

#define PRILIS	0177
#define REMCHR	012
#define __FITM	0256
#define STREQD	0111
#define PGNNFL	0176
#define SGACS	0146
#define DIGS	0122
#define STRLNK	01
#define LONG2	0131
#define FNAME	0124
#define LEABOT	063
#define ITMTOP	062
#define SGCWAS	0116
#define TIMER	0220
#define IJBCNI	0233
#define DFRINF	0231
#define CLER	00
#define TGRADJ	0247
#define OFFSET	0107
#define JFRCEL	0242
#define MAXITM	045
#define RACS	0133
#define SRELOC	0117
#define PROJ	0132
#define SGCCNT	0112
#define RSGCLK	0243
#define __PROU	0253
#define ENDREN	0274
#define _FSLIS	0237
#define STKURT	0222
#define SETLNK	03
#define SGCTOT	0114

#define STBUCK	0107
#define TOP	072
#define HASHP	055
#define OLDITM	046
#define CHANS	014
#define GGDAD	0217
#define CDBLOC	0123
#define KNTLNK	05
#define UUO1	00
#define INTQRP	0224
#define __FSTR	0261
#define SGCTIM	0113
#define INTQWB	0226
#define BUFACS	077
#define SGLIGN	013
#define BAILOC	0241

/*	added to PSAIL version */
#define DBUGRUNTIMES	0270	/* set 1 if debug runtimes else 0 */

/*   ---> End of <gogtab.h> <--- */
