/* 	File: PSRGLB.C 						*/
/*								*/
/*	SAIL <sairun> RUNTIME compatibility package for 	*/
/*	PSAIL - GLOBAL variable declarations.	 		*/
/*								*/
/*								*/
/*	P. Lemkin						*/
/*	Image Processing Section				*/
/*	National Cancer Institute, DCBD, LTB			*/
/*	FCRF, Build 469 Room 150B				*/
/*	Frederick, MD 21701					*/
/*
*    COPYRIGHT NOTICE - Copyright (c) 1983-1987 by Peter F. Lemkin.
*                     All rights reserved.
*       Permission is granted to any individual or institution to
*       copy, use or modify this program, except for explicitly
*       commercial purposes, provided this copyright notice is
*       included in its entirety in all derived works.  No warranty
*       of the software or of the accuracy of any documentation
*       surrounding it is expressed or implied, and the author does
*       not acknowledge any liability resulting from program or
*       documentation errors.
*/
/*								*/
/*	Version: 57.10						*/
/*								*/
/*	Revised September 7, 1987			        */
/*	Revised June 30, 1987			        	*/
/*	Revised June 26, 1987			        	*/
/*	Revised December 21, 1986				*/
/*	Revised September 20, 1986				*/
/*	Revised June 26, 1986					*/
/*	Revised March 5, 1986					*/
/*	Revised February 28, 1986				*/
/*	Revised December 2, 1985				*/
/*	June 29, 1984						*/
/*								*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/
/*	+    G L O B A L    V A R I A B L E S / M A C R O S	*/
/*	+++++++++++++++++++++++++++++++++++++++++++++++++	*/

#ifndef HASCONFIG
#include "config.h"	/* declare HAS... macros */
#endif

#ifndef PNULL
#include "psrdef.h"	/* need <sairun.c> compile-time macros */
#endif

INTEGER p_width=13;	 	/* default string CV... functions */
INTEGER p_prec=8;		/* default string CV... functions */
				/* field width and precision */

INTEGER gc_allocsize=2048;	/* Initial salloc() storage allocation*/
INTEGER gc_saftyfactor=512;	/* Safety factor in salloc() storage */


/* ---> END OF PSRGLB.C <--- */
